import{s as ea,f as nt,o as aa}from"../chunks/scheduler.37c15a92.js";import{S as sa,i as na,g as n,s as l,r as ne,m as g,H as it,A as la,h as i,f as e,c as o,j as y,u as le,x as p,n as v,B as ot,k as c,y as r,a as s,v as ie,d as oe,t as pe,w as re}from"../chunks/index.7cb9c9b8.js";import{T as ia}from"../chunks/Tip.d10b3fc9.js";import{H as ye}from"../chunks/Heading.d3928e2a.js";function oa(pt){let u;return{c(){u=g("But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},l(f){u=v(f,"But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},m(f,x){s(f,u,x)},d(f){f&&e(u)}}}function pa(pt){let u,f,x,rt,_,ut,T,xe="In value-based methods, <strong>we learn a value function</strong> that <strong>maps a state to the expected value of being at that state.</strong>",ct,M,_e,mt,b,Te="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts at that state and then acts according to our policy.</strong>",ht,d,ft,L,Me="Remember that the goal of an <strong>RL agent is to have an optimal policy π*.</strong>",gt,H,be="To find the optimal policy, we learned about two different methods:",vt,$,Le="<li><em>Policy-based methods:</em> <strong>Directly train the policy</strong> to select what action to take given a state (or a probability distribution over actions at that state). In this case, we <strong>don’t have a value function.</strong></li>",dt,C,He,wt,k,$e="The policy takes a state as input and outputs what action to take at that state (deterministic policy: a policy that output one action given a state, contrary to stochastic policy that output a probability distribution over actions).",yt,P,Ce="And consequently, <strong>we don’t define by hand the behavior of our policy; it’s the training that will define it.</strong>",xt,I,ke="<li><em>Value-based methods:</em> <strong>Indirectly, by training a value function</strong> that outputs the value of a state or a state-action pair. Given this value function, our policy <strong>will take an action.</strong></li>",_t,G,Pe="Since the policy is not trained/learned, <strong>we need to specify its behavior.</strong> For instance, if we want a policy that, given the value function, will take actions that always lead to the biggest reward, <strong>we’ll create a Greedy Policy.</strong>",Tt,S,Ie='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-3.jpg" alt="Two RL approaches"/> <figcaption>Given a state, our action-value function (that we train) outputs the value of each action at that state. Then, our pre-defined Greedy Policy selects the action that will yield the highest value given a state or a state action pair.</figcaption>',Mt,E,Ge="Consequently, whatever method you use to solve your problem, <strong>you will have a policy</strong>. In the case of value-based methods, you don’t train the policy: your policy <strong>is just a simple pre-specified function</strong> (for instance, the Greedy Policy) that uses the values given by the value-function to select its actions.",bt,j,Se="So the difference is:",Lt,q,Ee="<li>In policy-based training, <strong>the optimal policy (denoted π*) is found by training the policy directly.</strong></li> <li>In value-based training, <strong>finding an optimal value function (denoted Q* or V*, we’ll study the difference below) leads to having an optimal policy.</strong></li>",Ht,A,je,$t,z,qe="In fact, most of the time, in value-based methods, you’ll use <strong>an Epsilon-Greedy Policy</strong> that handles the exploration/exploitation trade-off; we’ll talk about this when we talk about Q-Learning in the second part of this unit.",Ct,R,Ae="As we mentioned above, we have two types of value-based functions:",kt,F,Pt,U,ze="We write the state value function under a policy π like this:",It,B,Re,Gt,N,Fe="For each state, the state-value function outputs the expected return if the agent <strong>starts at that state</strong> and then follows the policy forever afterward (for all future timesteps, if you prefer).",St,V,Ue='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-2.jpg" alt="State value function"/> <figcaption>If we take the state with value -7: it&#39;s the expected return starting at that state and taking actions according to our policy (greedy policy), so right, right, right, down, down, right, right.</figcaption>',Et,W,jt,O,Be="In the action-value function, for each state and action pair, the action-value function <strong>outputs the expected return</strong> if the agent starts in that state, takes that action, and then follows the policy forever after.",qt,m,ue,At,Ke='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>a</mi></mrow><annotation encoding="application/x-tex">a</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">a</span></span></span></span>',zt,Rt,Xe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>s</mi></mrow><annotation encoding="application/x-tex">s</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">s</span></span></span></span>',Ft,Ut,Ye='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">π</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Bt,Nt,Q,Ne,Vt,D,Ve,Wt,J,We="We see that the difference is:",Ot,w,et,ce,at,me,Qt,Ze='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',he,st,fe,K,ge,Dt,ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t, A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8778em;vertical-align:-0.1944em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Jt,Kt,X,Oe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-types.jpg" alt="Two types of value function"/> <figcaption>Note: We didn&#39;t fill all the state-action pairs for the example of Action-value function</figcaption>',Xt,Y,Qe="In either case, whichever value function we choose (state-value or action-value function), <strong>the returned value is the expected return.</strong>",Yt,Z,De="However, the problem is that <strong>to calculate EACH value of a state or a state-action pair, we need to sum all the rewards an agent can get if it starts at that state.</strong>",Zt,tt,Je="This can be a computationally expensive process, and that’s <strong>where the Bellman equation comes in to help us.</strong>",te,lt,ee;return _=new ye({props:{title:"Two types of value-based methods",local:"two-types-value-based-methods",headingTag:"h1"}}),d=new ia({props:{$$slots:{default:[oa]},$$scope:{ctx:pt}}}),F=new ye({props:{title:"The state-value function",local:"state-value-function",headingTag:"h2"}}),W=new ye({props:{title:"The action-value function",local:"action-value-function",headingTag:"h2"}}),{c(){u=n("meta"),f=l(),x=n("p"),rt=l(),ne(_.$$.fragment),ut=l(),T=n("p"),T.innerHTML=xe,ct=l(),M=n("img"),mt=l(),b=n("p"),b.innerHTML=Te,ht=l(),ne(d.$$.fragment),ft=l(),L=n("p"),L.innerHTML=Me,gt=l(),H=n("p"),H.textContent=be,vt=l(),$=n("ul"),$.innerHTML=Le,dt=l(),C=n("img"),wt=l(),k=n("p"),k.textContent=$e,yt=l(),P=n("p"),P.innerHTML=Ce,xt=l(),I=n("ul"),I.innerHTML=ke,_t=l(),G=n("p"),G.innerHTML=Pe,Tt=l(),S=n("figure"),S.innerHTML=Ie,Mt=l(),E=n("p"),E.innerHTML=Ge,bt=l(),j=n("p"),j.textContent=Se,Lt=l(),q=n("ul"),q.innerHTML=Ee,Ht=l(),A=n("img"),$t=l(),z=n("p"),z.innerHTML=qe,Ct=l(),R=n("p"),R.textContent=Ae,kt=l(),ne(F.$$.fragment),Pt=l(),U=n("p"),U.textContent=ze,It=l(),B=n("img"),Gt=l(),N=n("p"),N.innerHTML=Fe,St=l(),V=n("figure"),V.innerHTML=Ue,Et=l(),ne(W.$$.fragment),jt=l(),O=n("p"),O.innerHTML=Be,qt=l(),m=n("p"),ue=g("The value of taking action "),At=new it(!1),zt=g(" in state "),Rt=new it(!1),Ft=g(" under a policy "),Ut=new it(!1),Bt=g(" is:"),Nt=l(),Q=n("img"),Vt=l(),D=n("img"),Wt=l(),J=n("p"),J.textContent=We,Ot=l(),w=n("ul"),et=n("li"),ce=g("For the state-value function, we calculate "),at=n("strong"),me=g("the value of a state "),Qt=new it(!1),he=l(),st=n("li"),fe=g("For the action-value function, we calculate "),K=n("strong"),ge=g("the value of the state-action pair ( "),Dt=new it(!1),Jt=g(" ) hence the value of taking that action at that state."),Kt=l(),X=n("figure"),X.innerHTML=Oe,Xt=l(),Y=n("p"),Y.innerHTML=Qe,Yt=l(),Z=n("p"),Z.innerHTML=De,Zt=l(),tt=n("p"),tt.innerHTML=Je,te=l(),lt=n("p"),this.h()},l(t){const a=la("svelte-u9bgzb",document.head);u=i(a,"META",{name:!0,content:!0}),a.forEach(e),f=o(t),x=i(t,"P",{}),y(x).forEach(e),rt=o(t),le(_.$$.fragment,t),ut=o(t),T=i(t,"P",{"data-svelte-h":!0}),p(T)!=="svelte-1d7evji"&&(T.innerHTML=xe),ct=o(t),M=i(t,"IMG",{src:!0,alt:!0}),mt=o(t),b=i(t,"P",{"data-svelte-h":!0}),p(b)!=="svelte-12fd7se"&&(b.innerHTML=Te),ht=o(t),le(d.$$.fragment,t),ft=o(t),L=i(t,"P",{"data-svelte-h":!0}),p(L)!=="svelte-1urwfmu"&&(L.innerHTML=Me),gt=o(t),H=i(t,"P",{"data-svelte-h":!0}),p(H)!=="svelte-19ygivo"&&(H.textContent=be),vt=o(t),$=i(t,"UL",{"data-svelte-h":!0}),p($)!=="svelte-1ecrory"&&($.innerHTML=Le),dt=o(t),C=i(t,"IMG",{src:!0,alt:!0}),wt=o(t),k=i(t,"P",{"data-svelte-h":!0}),p(k)!=="svelte-8jz7zd"&&(k.textContent=$e),yt=o(t),P=i(t,"P",{"data-svelte-h":!0}),p(P)!=="svelte-pqtqep"&&(P.innerHTML=Ce),xt=o(t),I=i(t,"UL",{"data-svelte-h":!0}),p(I)!=="svelte-1vmcwmn"&&(I.innerHTML=ke),_t=o(t),G=i(t,"P",{"data-svelte-h":!0}),p(G)!=="svelte-1erga7r"&&(G.innerHTML=Pe),Tt=o(t),S=i(t,"FIGURE",{"data-svelte-h":!0}),p(S)!=="svelte-1wqg60u"&&(S.innerHTML=Ie),Mt=o(t),E=i(t,"P",{"data-svelte-h":!0}),p(E)!=="svelte-dnwvfq"&&(E.innerHTML=Ge),bt=o(t),j=i(t,"P",{"data-svelte-h":!0}),p(j)!=="svelte-5p6c4e"&&(j.textContent=Se),Lt=o(t),q=i(t,"UL",{"data-svelte-h":!0}),p(q)!=="svelte-b6yrau"&&(q.innerHTML=Ee),Ht=o(t),A=i(t,"IMG",{src:!0,alt:!0}),$t=o(t),z=i(t,"P",{"data-svelte-h":!0}),p(z)!=="svelte-3x2yxo"&&(z.innerHTML=qe),Ct=o(t),R=i(t,"P",{"data-svelte-h":!0}),p(R)!=="svelte-1iwwx7g"&&(R.textContent=Ae),kt=o(t),le(F.$$.fragment,t),Pt=o(t),U=i(t,"P",{"data-svelte-h":!0}),p(U)!=="svelte-h4xllq"&&(U.textContent=ze),It=o(t),B=i(t,"IMG",{src:!0,alt:!0}),Gt=o(t),N=i(t,"P",{"data-svelte-h":!0}),p(N)!=="svelte-19pqeuc"&&(N.innerHTML=Fe),St=o(t),V=i(t,"FIGURE",{"data-svelte-h":!0}),p(V)!=="svelte-ft3mq"&&(V.innerHTML=Ue),Et=o(t),le(W.$$.fragment,t),jt=o(t),O=i(t,"P",{"data-svelte-h":!0}),p(O)!=="svelte-1k21qix"&&(O.innerHTML=Be),qt=o(t),m=i(t,"P",{});var h=y(m);ue=v(h,"The value of taking action "),At=ot(h,!1),zt=v(h," in state "),Rt=ot(h,!1),Ft=v(h," under a policy "),Ut=ot(h,!1),Bt=v(h," is:"),h.forEach(e),Nt=o(t),Q=i(t,"IMG",{src:!0,alt:!0}),Vt=o(t),D=i(t,"IMG",{src:!0,alt:!0}),Wt=o(t),J=i(t,"P",{"data-svelte-h":!0}),p(J)!=="svelte-1n386nk"&&(J.textContent=We),Ot=o(t),w=i(t,"UL",{});var ae=y(w);et=i(ae,"LI",{});var ve=y(et);ce=v(ve,"For the state-value function, we calculate "),at=i(ve,"STRONG",{});var de=y(at);me=v(de,"the value of a state "),Qt=ot(de,!1),de.forEach(e),ve.forEach(e),he=o(ae),st=i(ae,"LI",{});var we=y(st);fe=v(we,"For the action-value function, we calculate "),K=i(we,"STRONG",{});var se=y(K);ge=v(se,"the value of the state-action pair ( "),Dt=ot(se,!1),Jt=v(se," ) hence the value of taking that action at that state."),se.forEach(e),we.forEach(e),ae.forEach(e),Kt=o(t),X=i(t,"FIGURE",{"data-svelte-h":!0}),p(X)!=="svelte-74fuwd"&&(X.innerHTML=Oe),Xt=o(t),Y=i(t,"P",{"data-svelte-h":!0}),p(Y)!=="svelte-b9olrp"&&(Y.innerHTML=Qe),Yt=o(t),Z=i(t,"P",{"data-svelte-h":!0}),p(Z)!=="svelte-1vktjwi"&&(Z.innerHTML=De),Zt=o(t),tt=i(t,"P",{"data-svelte-h":!0}),p(tt)!=="svelte-1edmeo9"&&(tt.innerHTML=Je),te=o(t),lt=i(t,"P",{}),y(lt).forEach(e),this.h()},h(){c(u,"name","hf:doc:metadata"),c(u,"content",ra),nt(M.src,_e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/vbm-1.jpg")||c(M,"src",_e),c(M,"alt","Value Based Methods"),nt(C.src,He="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-2.jpg")||c(C,"src",He),c(C,"alt","Two RL approaches"),nt(A.src,je="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||c(A,"src",je),c(A,"alt","Link between value and policy"),nt(B.src,Re="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-1.jpg")||c(B,"src",Re),c(B,"alt","State value function"),At.a=zt,Rt.a=Ft,Ut.a=Bt,nt(Q.src,Ne="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-1.jpg")||c(Q,"src",Ne),c(Q,"alt","Action State value function"),nt(D.src,Ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-2.jpg")||c(D,"src",Ve),c(D,"alt","Action State value function"),Qt.a=null,Dt.a=Jt},m(t,a){r(document.head,u),s(t,f,a),s(t,x,a),s(t,rt,a),ie(_,t,a),s(t,ut,a),s(t,T,a),s(t,ct,a),s(t,M,a),s(t,mt,a),s(t,b,a),s(t,ht,a),ie(d,t,a),s(t,ft,a),s(t,L,a),s(t,gt,a),s(t,H,a),s(t,vt,a),s(t,$,a),s(t,dt,a),s(t,C,a),s(t,wt,a),s(t,k,a),s(t,yt,a),s(t,P,a),s(t,xt,a),s(t,I,a),s(t,_t,a),s(t,G,a),s(t,Tt,a),s(t,S,a),s(t,Mt,a),s(t,E,a),s(t,bt,a),s(t,j,a),s(t,Lt,a),s(t,q,a),s(t,Ht,a),s(t,A,a),s(t,$t,a),s(t,z,a),s(t,Ct,a),s(t,R,a),s(t,kt,a),ie(F,t,a),s(t,Pt,a),s(t,U,a),s(t,It,a),s(t,B,a),s(t,Gt,a),s(t,N,a),s(t,St,a),s(t,V,a),s(t,Et,a),ie(W,t,a),s(t,jt,a),s(t,O,a),s(t,qt,a),s(t,m,a),r(m,ue),At.m(Ke,m),r(m,zt),Rt.m(Xe,m),r(m,Ft),Ut.m(Ye,m),r(m,Bt),s(t,Nt,a),s(t,Q,a),s(t,Vt,a),s(t,D,a),s(t,Wt,a),s(t,J,a),s(t,Ot,a),s(t,w,a),r(w,et),r(et,ce),r(et,at),r(at,me),Qt.m(Ze,at),r(w,he),r(w,st),r(st,fe),r(st,K),r(K,ge),Dt.m(ta,K),r(K,Jt),s(t,Kt,a),s(t,X,a),s(t,Xt,a),s(t,Y,a),s(t,Yt,a),s(t,Z,a),s(t,Zt,a),s(t,tt,a),s(t,te,a),s(t,lt,a),ee=!0},p(t,[a]){const h={};a&2&&(h.$$scope={dirty:a,ctx:t}),d.$set(h)},i(t){ee||(oe(_.$$.fragment,t),oe(d.$$.fragment,t),oe(F.$$.fragment,t),oe(W.$$.fragment,t),ee=!0)},o(t){pe(_.$$.fragment,t),pe(d.$$.fragment,t),pe(F.$$.fragment,t),pe(W.$$.fragment,t),ee=!1},d(t){t&&(e(f),e(x),e(rt),e(ut),e(T),e(ct),e(M),e(mt),e(b),e(ht),e(ft),e(L),e(gt),e(H),e(vt),e($),e(dt),e(C),e(wt),e(k),e(yt),e(P),e(xt),e(I),e(_t),e(G),e(Tt),e(S),e(Mt),e(E),e(bt),e(j),e(Lt),e(q),e(Ht),e(A),e($t),e(z),e(Ct),e(R),e(kt),e(Pt),e(U),e(It),e(B),e(Gt),e(N),e(St),e(V),e(Et),e(jt),e(O),e(qt),e(m),e(Nt),e(Q),e(Vt),e(D),e(Wt),e(J),e(Ot),e(w),e(Kt),e(X),e(Xt),e(Y),e(Yt),e(Z),e(Zt),e(tt),e(te),e(lt)),e(u),re(_,t),re(d,t),re(F,t),re(W,t)}}}const ra='{"title":"Two types of value-based methods","local":"two-types-value-based-methods","sections":[{"title":"The state-value function","local":"state-value-function","sections":[],"depth":2},{"title":"The action-value function","local":"action-value-function","sections":[],"depth":2}],"depth":1}';function ua(pt){return aa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ga extends sa{constructor(u){super(),na(this,u,ua,pa,ea,{})}}export{ga as component};
