import{s as Ml,f as kt,n as kl,o as Ll}from"../chunks/scheduler.37c15a92.js";import{S as Cl,i as Tl,g as l,s as m,r as Dt,m as r,H as h,A as Pl,h as i,f as a,c as p,j as u,u as Ft,n as o,B as c,x as g,k as d,y as n,a as e,v as Bt,d as Kt,t as Qt,w as Vt}from"../chunks/index.7cb9c9b8.js";import{H as Xt}from"../chunks/Heading.d3928e2a.js";function zl(Xe){let z,la,Yt,ia,N,ma,A,pa,M,be,ra,Nn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex"> \\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',oa,Lt,Ye="maximize the expected return",_e,ha,D,Ze="The idea is that we have a <em>parameterized stochastic policy</em>. In our case, a neural network outputs a probability distribution over actions. The probability of taking each action is also called the <em>action preference</em>.",ca,F,tn="If we take the example of CartPole-v1:",ga,B,an="<li>As input, we have a state.</li> <li>As output, we have a probability distribution over actions at that state.</li>",ua,K,sn,da,Q,en=`Our goal with policy-gradient is to <strong>control the probability distribution of actions</strong> by tuning the policy such that <strong>good actions (that maximize the return) are sampled more frequently in the future.</strong>
Each time the agent interacts with the environment, we tweak the parameters such that good actions will be sampled more likely in the future.`,fa,V,nn="But <strong>how are we going to optimize the weights using the expected return</strong>?",wa,X,ln=`The idea is that we’re going to <strong>let the agent interact during an episode</strong>. And if we win the episode, we consider that each action taken was good and must be more sampled in the future
since they lead to win.`,va,j,Me,ya,An='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>a</mi><mi mathvariant="normal">∣</mi><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(a|s)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal">a</span><span class="mord">∣</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',xa,ba,Y,mn="The Policy-gradient algorithm (simplified) looks like this:",_a,E,pn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/pg_bigpicture.jpg" alt="Policy Gradient Big Picture"/>',Ma,Z,rn="Now that we got the big picture, let’s dive deeper into policy-gradient methods.",ka,tt,La,w,ke,Ca,Dn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Ta,Pa,Fn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',za,$a,Bn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">\\pi</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',ja,Ct,on="outputs a probability distribution of actions",Le,Ea,H,hn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/stochastic_policy.png" alt="Policy"/>',Ha,y,Ce,Ra,Kn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ia,Ga,Qn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ja,Ua,Vn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Oa,Wa,$,Tt,cn="But how do we know if our policy is good?",Te,qa,Xn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Sa,Na,at,Aa,st,gn="The <em>objective function</em> gives us the <strong>performance of the agent</strong> given a trajectory (state action sequence without considering reward (contrary to an episode)), and it outputs the <em>expected cumulative reward</em>.",Da,et,un,Fa,nt,dn="Let’s give some more details on this formula:",Ba,Pt,b,Pe,zt,fn="expected return",ze,Ka,Yn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Qa,Va,Zn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',Xa,Ya,lt,wn,Za,R,$t,ts,tl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',as,$e,k,ss,al='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>P</mi><mo stretchy="false">(</mo><mi>τ</mi><mo separator="true">;</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">P(\\tau;\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">P</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mpunct">;</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',es,ns,sl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',ls,is,el='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex"> \\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',ms,ps,it,vn,rs,jt,I,os,nl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',hs,cs,ll='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',gs,us,G,je,ds,il='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',fs,ws,mt,yn,vs,pt,ys,f,Ee,xs,ml='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',bs,_s,pl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Ms,Et,xn="gradient-ascent",He,Ht,bn="gradient-descent",Re,ks,rl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Ls,Cs,rt,_n='(If you need a refresher on the difference between gradient descent and gradient ascent <a href="https://www.baeldung.com/cs/gradient-descent-vs-ascent" rel="nofollow">check this</a> and <a href="https://stats.stackexchange.com/questions/258721/gradient-ascent-vs-gradient-descent-in-logistic-regression" rel="nofollow">this</a>).',Ts,ot,Mn="Our update step for gradient-ascent is:",Ps,Rt,zs,ol='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mo>∗</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\theta \\leftarrow \\theta + \\alpha *  \\nabla_\\theta J(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4653em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',$s,L,Ie,js,hl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Es,Hs,cl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Rs,Is,J,Ge,Gs,gl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Js,Us,ht,kn=`<li><p>We can’t calculate the true gradient of the objective function since it requires calculating the probability of each possible trajectory, which is computationally super expensive.
So we want to <strong>calculate a gradient estimation with a sample-based estimate (collect some trajectories)</strong>.</p></li> <li><p>We have another problem that I explain in the next optional section. To differentiate this objective function, we need to differentiate the state distribution, called the Markov Decision Process dynamics. This is attached to the environment. It gives us the probability of the environment going into the next state, given the current state and the action taken by the agent. The problem is that we can’t differentiate it because we might not know about it.</p></li>`,Os,ct,Ln,Ws,gt,Cn="Fortunately we’re going to use a solution called the Policy Gradient Theorem that will help us to reformulate the objective function into a differentiable function that does not involve the differentiation of the state distribution.",qs,ut,Tn,Ss,dt,Pn="If you want to understand how we derive this formula for approximating the gradient, check out the next (optional) section.",Ns,ft,As,C,Je,It,zn="uses an estimated return from an entire episode to update the policy parameter",Ue,Ds,ul='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi></mrow><annotation encoding="application/x-tex">\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span></span></span></span>',Fs,Bs,wt,$n="In a loop:",Ks,T,Zt,U,Oe,Qs,dl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub></mrow><annotation encoding="application/x-tex">\\pi_\\theta</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Vs,Xs,fl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>τ</mi></mrow><annotation encoding="application/x-tex">\\tau</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span></span></span></span>',We,vt,Gt,qe,Ys,wl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mover accent="true"><mi>g</mi><mo>^</mo></mover><mo>=</mo><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>J</mi><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\hat{g} = \\nabla_\\theta J(\\theta)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.09618em;">J</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Se,yt,jn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_one.png" alt="Policy Gradient"/>',Ne,ta,Jt,Ae,Zs,vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>θ</mi><mo>←</mo><mi>θ</mi><mo>+</mo><mi>α</mi><mover accent="true"><mi>g</mi><mo>^</mo></mover></mrow><annotation encoding="application/x-tex">\\theta \\leftarrow \\theta + \\alpha \\hat{g}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">←</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7778em;vertical-align:-0.0833em;"></span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.0037em;">α</span><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.2222em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span></span></span></span>',te,xt,En="We can interpret this update as follows:",ae,O,v,se,yl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi mathvariant="normal">∇</mi><mi>θ</mi></msub><mi>l</mi><mi>o</mi><mi>g</mi><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><msub><mi>a</mi><mi>t</mi></msub><mi mathvariant="normal">∣</mi><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">\\nabla_\\theta log \\pi_\\theta(a_t|s_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord">∇</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal">o</span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ee,Ut,Hn="steepest increase of the (log) probability",De,Ot,Rn="how we should change the weights of policy",Fe,ne,xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">a_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',le,ie,bl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">s_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',me,Be,bt,pe,_l='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>R</mi><mo stretchy="false">(</mo><mi>τ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">R(\\tau)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.1132em;">τ</span><span class="mclose">)</span></span></span></span>',re,Wt,In="<li>If the return is high, it will <strong>push up the probabilities</strong> of the (state, action) combinations.</li> <li>Otherwise, if the return is low, it will <strong>push down the probabilities</strong> of the (state, action) combinations.</li>",oe,_t,Gn="We can also <strong>collect multiple episodes (trajectories)</strong> to estimate the gradient:",he,W,Jn='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_multiple.png" alt="Policy Gradient"/>',ce,aa,ge;return N=new Xt({props:{title:"Diving deeper into policy-gradient methods",local:"diving-deeper-into-policy-gradient-methods",headingTag:"h1"}}),A=new Xt({props:{title:"Getting the big picture",local:"getting-the-big-picture",headingTag:"h2"}}),tt=new Xt({props:{title:"Diving deeper into policy-gradient methods",local:"diving-deeper-into-policy-gradient-methods",headingTag:"h2"}}),at=new Xt({props:{title:"The objective function",local:"the-objective-function",headingTag:"h3"}}),pt=new Xt({props:{title:"Gradient Ascent and the Policy-gradient Theorem",local:"gradient-ascent-and-the-policy-gradient-theorem",headingTag:"h2"}}),ft=new Xt({props:{title:"The Reinforce algorithm (Monte Carlo Reinforce)",local:"the-reinforce-algorithm-monte-carlo-reinforce",headingTag:"h2"}}),{c(){z=l("meta"),la=m(),Yt=l("p"),ia=m(),Dt(N.$$.fragment),ma=m(),Dt(A.$$.fragment),pa=m(),M=l("p"),be=r("We just learned that policy-gradient methods aim to find parameters "),ra=new h(!1),oa=r(" that "),Lt=l("strong"),Lt.textContent=Ye,_e=r("."),ha=m(),D=l("p"),D.innerHTML=Ze,ca=m(),F=l("p"),F.textContent=tn,ga=m(),B=l("ul"),B.innerHTML=an,ua=m(),K=l("img"),da=m(),Q=l("p"),Q.innerHTML=en,fa=m(),V=l("p"),V.innerHTML=nn,wa=m(),X=l("p"),X.innerHTML=ln,va=m(),j=l("p"),Me=r("So for each state-action pair, we want to increase the "),ya=new h(!1),xa=r(": the probability of taking that action at that state. Or decrease if we lost."),ba=m(),Y=l("p"),Y.textContent=mn,_a=m(),E=l("figure"),E.innerHTML=pn,Ma=m(),Z=l("p"),Z.textContent=rn,ka=m(),Dt(tt.$$.fragment),La=m(),w=l("p"),ke=r("We have our stochastic policy "),Ca=new h(!1),Ta=r(" which has a parameter "),Pa=new h(!1),za=r(". This "),$a=new h(!1),ja=r(", given a state, "),Ct=l("strong"),Ct.textContent=on,Le=r("."),Ea=m(),H=l("figure"),H.innerHTML=hn,Ha=m(),y=l("p"),Ce=r("Where "),Ra=new h(!1),Ia=r(" is the probability of the agent selecting action "),Ga=new h(!1),Ja=r(" from state "),Ua=new h(!1),Oa=r(" given our policy."),Wa=m(),$=l("p"),Tt=l("strong"),Tt.textContent=cn,Te=r(" We need to have a way to measure it. To know that, we define a score/objective function called "),qa=new h(!1),Sa=r("."),Na=m(),Dt(at.$$.fragment),Aa=m(),st=l("p"),st.innerHTML=gn,Da=m(),et=l("img"),Fa=m(),nt=l("p"),nt.textContent=dn,Ba=m(),Pt=l("ul"),b=l("li"),Pe=r("The "),zt=l("em"),zt.textContent=fn,ze=r(" (also called expected cumulative reward), is the weighted average (where the weights are given by "),Ka=new h(!1),Qa=r(" of all possible values that the return "),Va=new h(!1),Xa=r(" can take)."),Ya=m(),lt=l("img"),Za=m(),R=l("ul"),$t=l("li"),ts=new h(!1),as=r(" :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),$e=m(),k=l("li"),ss=new h(!1),es=r(" : Probability of each possible trajectory "),ns=new h(!1),ls=r(" (that probability depends on "),is=new h(!1),ms=r(" since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),ps=m(),it=l("img"),rs=m(),jt=l("ul"),I=l("li"),os=new h(!1),hs=r(" : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),cs=new h(!1),gs=r(" multiplied by the return of this trajectory."),us=m(),G=l("p"),je=r("Our objective then is to maximize the expected cumulative reward by finding the "),ds=new h(!1),fs=r(" that will output the best action probability distributions:"),ws=m(),mt=l("img"),vs=m(),Dt(pt.$$.fragment),ys=m(),f=l("p"),Ee=r("Policy-gradient is an optimization problem: we want to find the values of "),xs=new h(!1),bs=r(" that maximize our objective function "),_s=new h(!1),Ms=r(", so we need to use "),Et=l("strong"),Et.textContent=xn,He=r(". It’s the inverse of "),Ht=l("em"),Ht.textContent=bn,Re=r(" since it gives the direction of the steepest increase of "),ks=new h(!1),Ls=r("."),Cs=m(),rt=l("p"),rt.innerHTML=_n,Ts=m(),ot=l("p"),ot.textContent=Mn,Ps=m(),Rt=l("p"),zs=new h(!1),$s=m(),L=l("p"),Ie=r("We can repeatedly apply this update in the hopes that "),js=new h(!1),Es=r(" converges to the value that maximizes "),Hs=new h(!1),Rs=r("."),Is=m(),J=l("p"),Ge=r("However, there are two problems with computing the derivative of "),Gs=new h(!1),Js=r(":"),Us=m(),ht=l("ol"),ht.innerHTML=kn,Os=m(),ct=l("img"),Ws=m(),gt=l("p"),gt.textContent=Cn,qs=m(),ut=l("img"),Ss=m(),dt=l("p"),dt.textContent=Pn,Ns=m(),Dt(ft.$$.fragment),As=m(),C=l("p"),Je=r("The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),It=l("strong"),It.textContent=zn,Ue=m(),Ds=new h(!1),Fs=r(":"),Bs=m(),wt=l("p"),wt.textContent=$n,Ks=m(),T=l("ul"),Zt=l("li"),U=l("p"),Oe=r("Use the policy "),Qs=new h(!1),Vs=r("  to collect an episode "),Xs=new h(!1),We=m(),vt=l("li"),Gt=l("p"),qe=r("Use the episode to estimate the gradient "),Ys=new h(!1),Se=m(),yt=l("figure"),yt.innerHTML=jn,Ne=m(),ta=l("li"),Jt=l("p"),Ae=r("Update the weights of the policy: "),Zs=new h(!1),te=m(),xt=l("p"),xt.textContent=En,ae=m(),O=l("ul"),v=l("li"),se=new h(!1),ee=r(" is the direction of "),Ut=l("strong"),Ut.textContent=Hn,De=r(` of selecting action at from state st.
This tells us `),Ot=l("strong"),Ot.textContent=Rn,Fe=r(" if we want to increase/decrease the log probability of selecting action "),ne=new h(!1),le=r(" at state "),ie=new h(!1),me=r("."),Be=m(),bt=l("li"),pe=new h(!1),re=r(": is the scoring function:"),Wt=l("ul"),Wt.innerHTML=In,oe=m(),_t=l("p"),_t.innerHTML=Gn,he=m(),W=l("figure"),W.innerHTML=Jn,ce=m(),aa=l("p"),this.h()},l(t){const s=Pl("svelte-u9bgzb",document.head);z=i(s,"META",{name:!0,content:!0}),s.forEach(a),la=p(t),Yt=i(t,"P",{}),u(Yt).forEach(a),ia=p(t),Ft(N.$$.fragment,t),ma=p(t),Ft(A.$$.fragment,t),pa=p(t),M=i(t,"P",{});var qt=u(M);be=o(qt,"We just learned that policy-gradient methods aim to find parameters "),ra=c(qt,!1),oa=o(qt," that "),Lt=i(qt,"STRONG",{"data-svelte-h":!0}),g(Lt)!=="svelte-1vrdngf"&&(Lt.textContent=Ye),_e=o(qt,"."),qt.forEach(a),ha=p(t),D=i(t,"P",{"data-svelte-h":!0}),g(D)!=="svelte-1ocflgo"&&(D.innerHTML=Ze),ca=p(t),F=i(t,"P",{"data-svelte-h":!0}),g(F)!=="svelte-okfb72"&&(F.textContent=tn),ga=p(t),B=i(t,"UL",{"data-svelte-h":!0}),g(B)!=="svelte-bs6s8l"&&(B.innerHTML=an),ua=p(t),K=i(t,"IMG",{src:!0,alt:!0}),da=p(t),Q=i(t,"P",{"data-svelte-h":!0}),g(Q)!=="svelte-1usf972"&&(Q.innerHTML=en),fa=p(t),V=i(t,"P",{"data-svelte-h":!0}),g(V)!=="svelte-y55wye"&&(V.innerHTML=nn),wa=p(t),X=i(t,"P",{"data-svelte-h":!0}),g(X)!=="svelte-1r32kyr"&&(X.innerHTML=ln),va=p(t),j=i(t,"P",{});var ue=u(j);Me=o(ue,"So for each state-action pair, we want to increase the "),ya=c(ue,!1),xa=o(ue,": the probability of taking that action at that state. Or decrease if we lost."),ue.forEach(a),ba=p(t),Y=i(t,"P",{"data-svelte-h":!0}),g(Y)!=="svelte-368gi1"&&(Y.textContent=mn),_a=p(t),E=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(E)!=="svelte-r97oyl"&&(E.innerHTML=pn),Ma=p(t),Z=i(t,"P",{"data-svelte-h":!0}),g(Z)!=="svelte-h48cfn"&&(Z.textContent=rn),ka=p(t),Ft(tt.$$.fragment,t),La=p(t),w=i(t,"P",{});var P=u(w);ke=o(P,"We have our stochastic policy "),Ca=c(P,!1),Ta=o(P," which has a parameter "),Pa=c(P,!1),za=o(P,". This "),$a=c(P,!1),ja=o(P,", given a state, "),Ct=i(P,"STRONG",{"data-svelte-h":!0}),g(Ct)!=="svelte-hu1hfg"&&(Ct.textContent=on),Le=o(P,"."),P.forEach(a),Ea=p(t),H=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(H)!=="svelte-1l2lqzr"&&(H.innerHTML=hn),Ha=p(t),y=i(t,"P",{});var q=u(y);Ce=o(q,"Where "),Ra=c(q,!1),Ia=o(q," is the probability of the agent selecting action "),Ga=c(q,!1),Ja=o(q," from state "),Ua=c(q,!1),Oa=o(q," given our policy."),q.forEach(a),Wa=p(t),$=i(t,"P",{});var sa=u($);Tt=i(sa,"STRONG",{"data-svelte-h":!0}),g(Tt)!=="svelte-1i8sglg"&&(Tt.textContent=cn),Te=o(sa," We need to have a way to measure it. To know that, we define a score/objective function called "),qa=c(sa,!1),Sa=o(sa,"."),sa.forEach(a),Na=p(t),Ft(at.$$.fragment,t),Aa=p(t),st=i(t,"P",{"data-svelte-h":!0}),g(st)!=="svelte-1xlu0oc"&&(st.innerHTML=gn),Da=p(t),et=i(t,"IMG",{src:!0,alt:!0}),Fa=p(t),nt=i(t,"P",{"data-svelte-h":!0}),g(nt)!=="svelte-7h4zyq"&&(nt.textContent=dn),Ba=p(t),Pt=i(t,"UL",{});var Un=u(Pt);b=i(Un,"LI",{});var S=u(b);Pe=o(S,"The "),zt=i(S,"EM",{"data-svelte-h":!0}),g(zt)!=="svelte-zzl69g"&&(zt.textContent=fn),ze=o(S," (also called expected cumulative reward), is the weighted average (where the weights are given by "),Ka=c(S,!1),Qa=o(S," of all possible values that the return "),Va=c(S,!1),Xa=o(S," can take)."),S.forEach(a),Un.forEach(a),Ya=p(t),lt=i(t,"IMG",{src:!0,alt:!0}),Za=p(t),R=i(t,"UL",{});var de=u(R);$t=i(de,"LI",{});var Ke=u($t);ts=c(Ke,!1),as=o(Ke," :  Return from an arbitrary trajectory. To take this quantity and use it to calculate the expected return, we need to multiply it by the probability of each possible trajectory."),Ke.forEach(a),$e=p(de),k=i(de,"LI",{});var Mt=u(k);ss=c(Mt,!1),es=o(Mt," : Probability of each possible trajectory "),ns=c(Mt,!1),ls=o(Mt," (that probability depends on "),is=c(Mt,!1),ms=o(Mt," since it defines the policy that it uses to select the actions of the trajectory which has an impact of the states visited)."),Mt.forEach(a),de.forEach(a),ps=p(t),it=i(t,"IMG",{src:!0,alt:!0}),rs=p(t),jt=i(t,"UL",{});var On=u(jt);I=i(On,"LI",{});var ea=u(I);os=c(ea,!1),hs=o(ea," : Expected return, we calculate it by summing for all trajectories, the probability of taking that trajectory given "),cs=c(ea,!1),gs=o(ea," multiplied by the return of this trajectory."),ea.forEach(a),On.forEach(a),us=p(t),G=i(t,"P",{});var fe=u(G);je=o(fe,"Our objective then is to maximize the expected cumulative reward by finding the "),ds=c(fe,!1),fs=o(fe," that will output the best action probability distributions:"),fe.forEach(a),ws=p(t),mt=i(t,"IMG",{src:!0,alt:!0}),vs=p(t),Ft(pt.$$.fragment,t),ys=p(t),f=i(t,"P",{});var x=u(f);Ee=o(x,"Policy-gradient is an optimization problem: we want to find the values of "),xs=c(x,!1),bs=o(x," that maximize our objective function "),_s=c(x,!1),Ms=o(x,", so we need to use "),Et=i(x,"STRONG",{"data-svelte-h":!0}),g(Et)!=="svelte-1m10mlp"&&(Et.textContent=xn),He=o(x,". It’s the inverse of "),Ht=i(x,"EM",{"data-svelte-h":!0}),g(Ht)!=="svelte-1h262ip"&&(Ht.textContent=bn),Re=o(x," since it gives the direction of the steepest increase of "),ks=c(x,!1),Ls=o(x,"."),x.forEach(a),Cs=p(t),rt=i(t,"P",{"data-svelte-h":!0}),g(rt)!=="svelte-tm5v0z"&&(rt.innerHTML=_n),Ts=p(t),ot=i(t,"P",{"data-svelte-h":!0}),g(ot)!=="svelte-bg30bb"&&(ot.textContent=Mn),Ps=p(t),Rt=i(t,"P",{});var Wn=u(Rt);zs=c(Wn,!1),Wn.forEach(a),$s=p(t),L=i(t,"P",{});var St=u(L);Ie=o(St,"We can repeatedly apply this update in the hopes that "),js=c(St,!1),Es=o(St," converges to the value that maximizes "),Hs=c(St,!1),Rs=o(St,"."),St.forEach(a),Is=p(t),J=i(t,"P",{});var we=u(J);Ge=o(we,"However, there are two problems with computing the derivative of "),Gs=c(we,!1),Js=o(we,":"),we.forEach(a),Us=p(t),ht=i(t,"OL",{"data-svelte-h":!0}),g(ht)!=="svelte-1ccvper"&&(ht.innerHTML=kn),Os=p(t),ct=i(t,"IMG",{src:!0,alt:!0}),Ws=p(t),gt=i(t,"P",{"data-svelte-h":!0}),g(gt)!=="svelte-mhy87w"&&(gt.textContent=Cn),qs=p(t),ut=i(t,"IMG",{src:!0,alt:!0}),Ss=p(t),dt=i(t,"P",{"data-svelte-h":!0}),g(dt)!=="svelte-12htye5"&&(dt.textContent=Pn),Ns=p(t),Ft(ft.$$.fragment,t),As=p(t),C=i(t,"P",{});var Nt=u(C);Je=o(Nt,"The Reinforce algorithm, also called Monte-Carlo policy-gradient, is a policy-gradient algorithm that "),It=i(Nt,"STRONG",{"data-svelte-h":!0}),g(It)!=="svelte-j30ps8"&&(It.textContent=zn),Ue=p(Nt),Ds=c(Nt,!1),Fs=o(Nt,":"),Nt.forEach(a),Bs=p(t),wt=i(t,"P",{"data-svelte-h":!0}),g(wt)!=="svelte-zhyuac"&&(wt.textContent=$n),Ks=p(t),T=i(t,"UL",{});var At=u(T);Zt=i(At,"LI",{});var qn=u(Zt);U=i(qn,"P",{});var na=u(U);Oe=o(na,"Use the policy "),Qs=c(na,!1),Vs=o(na,"  to collect an episode "),Xs=c(na,!1),na.forEach(a),qn.forEach(a),We=p(At),vt=i(At,"LI",{});var ve=u(vt);Gt=i(ve,"P",{});var Qe=u(Gt);qe=o(Qe,"Use the episode to estimate the gradient "),Ys=c(Qe,!1),Qe.forEach(a),Se=p(ve),yt=i(ve,"FIGURE",{class:!0,"data-svelte-h":!0}),g(yt)!=="svelte-1qgmq47"&&(yt.innerHTML=jn),ve.forEach(a),Ne=p(At),ta=i(At,"LI",{});var Sn=u(ta);Jt=i(Sn,"P",{});var Ve=u(Jt);Ae=o(Ve,"Update the weights of the policy: "),Zs=c(Ve,!1),Ve.forEach(a),Sn.forEach(a),At.forEach(a),te=p(t),xt=i(t,"P",{"data-svelte-h":!0}),g(xt)!=="svelte-1ubiwhq"&&(xt.textContent=En),ae=p(t),O=i(t,"UL",{});var ye=u(O);v=i(ye,"LI",{});var _=u(v);se=c(_,!1),ee=o(_," is the direction of "),Ut=i(_,"STRONG",{"data-svelte-h":!0}),g(Ut)!=="svelte-1od0czd"&&(Ut.textContent=Hn),De=o(_,` of selecting action at from state st.
This tells us `),Ot=i(_,"STRONG",{"data-svelte-h":!0}),g(Ot)!=="svelte-v2e0ag"&&(Ot.textContent=Rn),Fe=o(_," if we want to increase/decrease the log probability of selecting action "),ne=c(_,!1),le=o(_," at state "),ie=c(_,!1),me=o(_,"."),_.forEach(a),Be=p(ye),bt=i(ye,"LI",{});var xe=u(bt);pe=c(xe,!1),re=o(xe,": is the scoring function:"),Wt=i(xe,"UL",{"data-svelte-h":!0}),g(Wt)!=="svelte-p5xd27"&&(Wt.innerHTML=In),xe.forEach(a),ye.forEach(a),oe=p(t),_t=i(t,"P",{"data-svelte-h":!0}),g(_t)!=="svelte-22wa60"&&(_t.innerHTML=Gn),he=p(t),W=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),g(W)!=="svelte-j15w63"&&(W.innerHTML=Jn),ce=p(t),aa=i(t,"P",{}),u(aa).forEach(a),this.h()},h(){d(z,"name","hf:doc:metadata"),d(z,"content",$l),ra.a=oa,kt(K.src,sn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_based.png")||d(K,"src",sn),d(K,"alt","Policy based"),ya.a=xa,d(E,"class","image table text-center m-0 w-full"),Ca.a=Ta,Pa.a=za,$a.a=ja,d(H,"class","image table text-center m-0 w-full"),Ra.a=Ia,Ga.a=Ja,Ua.a=Oa,qa.a=Sa,kt(et.src,un="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/objective.jpg")||d(et,"src",un),d(et,"alt","Return"),Ka.a=Qa,Va.a=Xa,kt(lt.src,wn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/expected_reward.png")||d(lt,"src",wn),d(lt,"alt","Return"),ts.a=as,ss.a=es,ns.a=ls,is.a=ms,kt(it.src,vn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||d(it,"src",vn),d(it,"alt","Probability"),os.a=hs,cs.a=gs,ds.a=fs,kt(mt.src,yn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/max_objective.png")||d(mt,"src",yn),d(mt,"alt","Max objective"),xs.a=bs,_s.a=Ms,ks.a=Ls,zs.a=null,js.a=Es,Hs.a=Rs,Gs.a=Js,kt(ct.src,Ln="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/probability.png")||d(ct,"src",Ln),d(ct,"alt","Probability"),kt(ut.src,Tn="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/policy_gradient_theorem.png")||d(ut,"src",Tn),d(ut,"alt","Policy Gradient"),Ds.a=Fs,Qs.a=Vs,Xs.a=null,Ys.a=null,d(yt,"class","image table text-center m-0 w-full"),Zs.a=null,se.a=ee,ne.a=le,ie.a=me,pe.a=re,d(W,"class","image table text-center m-0 w-full")},m(t,s){n(document.head,z),e(t,la,s),e(t,Yt,s),e(t,ia,s),Bt(N,t,s),e(t,ma,s),Bt(A,t,s),e(t,pa,s),e(t,M,s),n(M,be),ra.m(Nn,M),n(M,oa),n(M,Lt),n(M,_e),e(t,ha,s),e(t,D,s),e(t,ca,s),e(t,F,s),e(t,ga,s),e(t,B,s),e(t,ua,s),e(t,K,s),e(t,da,s),e(t,Q,s),e(t,fa,s),e(t,V,s),e(t,wa,s),e(t,X,s),e(t,va,s),e(t,j,s),n(j,Me),ya.m(An,j),n(j,xa),e(t,ba,s),e(t,Y,s),e(t,_a,s),e(t,E,s),e(t,Ma,s),e(t,Z,s),e(t,ka,s),Bt(tt,t,s),e(t,La,s),e(t,w,s),n(w,ke),Ca.m(Dn,w),n(w,Ta),Pa.m(Fn,w),n(w,za),$a.m(Bn,w),n(w,ja),n(w,Ct),n(w,Le),e(t,Ea,s),e(t,H,s),e(t,Ha,s),e(t,y,s),n(y,Ce),Ra.m(Kn,y),n(y,Ia),Ga.m(Qn,y),n(y,Ja),Ua.m(Vn,y),n(y,Oa),e(t,Wa,s),e(t,$,s),n($,Tt),n($,Te),qa.m(Xn,$),n($,Sa),e(t,Na,s),Bt(at,t,s),e(t,Aa,s),e(t,st,s),e(t,Da,s),e(t,et,s),e(t,Fa,s),e(t,nt,s),e(t,Ba,s),e(t,Pt,s),n(Pt,b),n(b,Pe),n(b,zt),n(b,ze),Ka.m(Yn,b),n(b,Qa),Va.m(Zn,b),n(b,Xa),e(t,Ya,s),e(t,lt,s),e(t,Za,s),e(t,R,s),n(R,$t),ts.m(tl,$t),n($t,as),n(R,$e),n(R,k),ss.m(al,k),n(k,es),ns.m(sl,k),n(k,ls),is.m(el,k),n(k,ms),e(t,ps,s),e(t,it,s),e(t,rs,s),e(t,jt,s),n(jt,I),os.m(nl,I),n(I,hs),cs.m(ll,I),n(I,gs),e(t,us,s),e(t,G,s),n(G,je),ds.m(il,G),n(G,fs),e(t,ws,s),e(t,mt,s),e(t,vs,s),Bt(pt,t,s),e(t,ys,s),e(t,f,s),n(f,Ee),xs.m(ml,f),n(f,bs),_s.m(pl,f),n(f,Ms),n(f,Et),n(f,He),n(f,Ht),n(f,Re),ks.m(rl,f),n(f,Ls),e(t,Cs,s),e(t,rt,s),e(t,Ts,s),e(t,ot,s),e(t,Ps,s),e(t,Rt,s),zs.m(ol,Rt),e(t,$s,s),e(t,L,s),n(L,Ie),js.m(hl,L),n(L,Es),Hs.m(cl,L),n(L,Rs),e(t,Is,s),e(t,J,s),n(J,Ge),Gs.m(gl,J),n(J,Js),e(t,Us,s),e(t,ht,s),e(t,Os,s),e(t,ct,s),e(t,Ws,s),e(t,gt,s),e(t,qs,s),e(t,ut,s),e(t,Ss,s),e(t,dt,s),e(t,Ns,s),Bt(ft,t,s),e(t,As,s),e(t,C,s),n(C,Je),n(C,It),n(C,Ue),Ds.m(ul,C),n(C,Fs),e(t,Bs,s),e(t,wt,s),e(t,Ks,s),e(t,T,s),n(T,Zt),n(Zt,U),n(U,Oe),Qs.m(dl,U),n(U,Vs),Xs.m(fl,U),n(T,We),n(T,vt),n(vt,Gt),n(Gt,qe),Ys.m(wl,Gt),n(vt,Se),n(vt,yt),n(T,Ne),n(T,ta),n(ta,Jt),n(Jt,Ae),Zs.m(vl,Jt),e(t,te,s),e(t,xt,s),e(t,ae,s),e(t,O,s),n(O,v),se.m(yl,v),n(v,ee),n(v,Ut),n(v,De),n(v,Ot),n(v,Fe),ne.m(xl,v),n(v,le),ie.m(bl,v),n(v,me),n(O,Be),n(O,bt),pe.m(_l,bt),n(bt,re),n(bt,Wt),e(t,oe,s),e(t,_t,s),e(t,he,s),e(t,W,s),e(t,ce,s),e(t,aa,s),ge=!0},p:kl,i(t){ge||(Kt(N.$$.fragment,t),Kt(A.$$.fragment,t),Kt(tt.$$.fragment,t),Kt(at.$$.fragment,t),Kt(pt.$$.fragment,t),Kt(ft.$$.fragment,t),ge=!0)},o(t){Qt(N.$$.fragment,t),Qt(A.$$.fragment,t),Qt(tt.$$.fragment,t),Qt(at.$$.fragment,t),Qt(pt.$$.fragment,t),Qt(ft.$$.fragment,t),ge=!1},d(t){t&&(a(la),a(Yt),a(ia),a(ma),a(pa),a(M),a(ha),a(D),a(ca),a(F),a(ga),a(B),a(ua),a(K),a(da),a(Q),a(fa),a(V),a(wa),a(X),a(va),a(j),a(ba),a(Y),a(_a),a(E),a(Ma),a(Z),a(ka),a(La),a(w),a(Ea),a(H),a(Ha),a(y),a(Wa),a($),a(Na),a(Aa),a(st),a(Da),a(et),a(Fa),a(nt),a(Ba),a(Pt),a(Ya),a(lt),a(Za),a(R),a(ps),a(it),a(rs),a(jt),a(us),a(G),a(ws),a(mt),a(vs),a(ys),a(f),a(Cs),a(rt),a(Ts),a(ot),a(Ps),a(Rt),a($s),a(L),a(Is),a(J),a(Us),a(ht),a(Os),a(ct),a(Ws),a(gt),a(qs),a(ut),a(Ss),a(dt),a(Ns),a(As),a(C),a(Bs),a(wt),a(Ks),a(T),a(te),a(xt),a(ae),a(O),a(oe),a(_t),a(he),a(W),a(ce),a(aa)),a(z),Vt(N,t),Vt(A,t),Vt(tt,t),Vt(at,t),Vt(pt,t),Vt(ft,t)}}}const $l='{"title":"Diving deeper into policy-gradient methods","local":"diving-deeper-into-policy-gradient-methods","sections":[{"title":"Getting the big picture","local":"getting-the-big-picture","sections":[],"depth":2},{"title":"Diving deeper into policy-gradient methods","local":"diving-deeper-into-policy-gradient-methods","sections":[{"title":"The objective function","local":"the-objective-function","sections":[],"depth":3}],"depth":2},{"title":"Gradient Ascent and the Policy-gradient Theorem","local":"gradient-ascent-and-the-policy-gradient-theorem","sections":[],"depth":2},{"title":"The Reinforce algorithm (Monte Carlo Reinforce)","local":"the-reinforce-algorithm-monte-carlo-reinforce","sections":[],"depth":2}],"depth":1}';function jl(Xe){return Ll(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Il extends Cl{constructor(z){super(),Tl(this,z,jl,zl,Ml,{})}}export{Il as component};
