import{s as nt,f as st,n as it,o as lt}from"../chunks/scheduler.37c15a92.js";import{S as ot,i as rt,g as s,s as l,r as mt,m as F,H as ct,A as pt,h as i,f as e,c as o,j as B,u as ut,x as c,n as N,B as ht,k as G,y as C,a as n,v as dt,d as gt,t as ft,w as vt}from"../chunks/index.7cb9c9b8.js";import{H as yt}from"../chunks/Heading.d3928e2a.js";function wt(V){let m,T,b,L,p,H,u,J,M,h,K="In Unit 6, we learned about Advantage Actor Critic (A2C), a hybrid architecture combining value-based and policy-based methods that helps to stabilize the training by reducing the variance with:",z,d,Q="<li><em>An Actor</em> that controls <strong>how our agent behaves</strong> (policy-based method).</li> <li><em>A Critic</em> that measures <strong>how good the action taken is</strong> (value-based method).</li>",$,r,j,x,W="improves our agent’s training stability by avoiding policy updates that are too large",q,A,at='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',O,k,g,X="Doing this will ensure <strong>that our policy update will not be too large and that the training is more stable.</strong>",E,f,Y="This Unit is in two parts:",I,v,Z='<li>In this first part, you’ll learn the theory behind PPO and code your PPO agent from scratch using the <a href="https://github.com/vwxyzjn/cleanrl" rel="nofollow">CleanRL</a> implementation. To test its robustness you’ll use LunarLander-v2. LunarLander-v2 <strong>is the first environment you used when you started this course</strong>. At that time, you didn’t know how PPO worked, and now, <strong>you can code it from scratch and train it. How incredible is that 🤩</strong>.</li> <li>In the second part, we’ll get deeper into PPO optimization by using <a href="https://samplefactory.dev/" rel="nofollow">Sample-Factory</a> and train an agent playing vizdoom (an open source version of Doom).</li>',U,y,tt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/environments.png" alt="Environment"/> <figcaption>These are the environments you&#39;re going to use to train your agents: VizDoom environments</figcaption>',S,w,et="Sound exciting? Let’s get started! 🚀",R,P,D;return p=new yt({props:{title:"Introduction",local:"introduction",headingTag:"h1"}}),{c(){m=s("meta"),T=l(),b=s("p"),L=l(),mt(p.$$.fragment),H=l(),u=s("img"),M=l(),h=s("p"),h.textContent=K,z=l(),d=s("ul"),d.innerHTML=Q,$=l(),r=s("p"),j=F("Today we’ll learn about Proximal Policy Optimization (PPO), an architecture that "),x=s("strong"),x.textContent=W,q=F(". To do that, we use a ratio that indicates the difference between our current and old policy and clip this ratio to a specific range "),A=new ct(!1),O=F(" ."),k=l(),g=s("p"),g.innerHTML=X,E=l(),f=s("p"),f.textContent=Y,I=l(),v=s("ul"),v.innerHTML=Z,U=l(),y=s("figure"),y.innerHTML=tt,S=l(),w=s("p"),w.textContent=et,R=l(),P=s("p"),this.h()},l(t){const a=pt("svelte-u9bgzb",document.head);m=i(a,"META",{name:!0,content:!0}),a.forEach(e),T=o(t),b=i(t,"P",{}),B(b).forEach(e),L=o(t),ut(p.$$.fragment,t),H=o(t),u=i(t,"IMG",{src:!0,alt:!0}),M=o(t),h=i(t,"P",{"data-svelte-h":!0}),c(h)!=="svelte-1028gae"&&(h.textContent=K),z=o(t),d=i(t,"UL",{"data-svelte-h":!0}),c(d)!=="svelte-1esiva3"&&(d.innerHTML=Q),$=o(t),r=i(t,"P",{});var _=B(r);j=N(_,"Today we’ll learn about Proximal Policy Optimization (PPO), an architecture that "),x=i(_,"STRONG",{"data-svelte-h":!0}),c(x)!=="svelte-20y8ah"&&(x.textContent=W),q=N(_,". To do that, we use a ratio that indicates the difference between our current and old policy and clip this ratio to a specific range "),A=ht(_,!1),O=N(_," ."),_.forEach(e),k=o(t),g=i(t,"P",{"data-svelte-h":!0}),c(g)!=="svelte-1tdswvm"&&(g.innerHTML=X),E=o(t),f=i(t,"P",{"data-svelte-h":!0}),c(f)!=="svelte-6tzgaz"&&(f.textContent=Y),I=o(t),v=i(t,"UL",{"data-svelte-h":!0}),c(v)!=="svelte-ktbxxa"&&(v.innerHTML=Z),U=o(t),y=i(t,"FIGURE",{"data-svelte-h":!0}),c(y)!=="svelte-87htwd"&&(y.innerHTML=tt),S=o(t),w=i(t,"P",{"data-svelte-h":!0}),c(w)!=="svelte-1i7vabt"&&(w.textContent=et),R=o(t),P=i(t,"P",{}),B(P).forEach(e),this.h()},h(){G(m,"name","hf:doc:metadata"),G(m,"content",xt),st(u.src,J="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/thumbnail.png")||G(u,"src",J),G(u,"alt","Unit 8"),A.a=O},m(t,a){C(document.head,m),n(t,T,a),n(t,b,a),n(t,L,a),dt(p,t,a),n(t,H,a),n(t,u,a),n(t,M,a),n(t,h,a),n(t,z,a),n(t,d,a),n(t,$,a),n(t,r,a),C(r,j),C(r,x),C(r,q),A.m(at,r),C(r,O),n(t,k,a),n(t,g,a),n(t,E,a),n(t,f,a),n(t,I,a),n(t,v,a),n(t,U,a),n(t,y,a),n(t,S,a),n(t,w,a),n(t,R,a),n(t,P,a),D=!0},p:it,i(t){D||(gt(p.$$.fragment,t),D=!0)},o(t){ft(p.$$.fragment,t),D=!1},d(t){t&&(e(T),e(b),e(L),e(H),e(u),e(M),e(h),e(z),e(d),e($),e(r),e(k),e(g),e(E),e(f),e(I),e(v),e(U),e(y),e(S),e(w),e(R),e(P)),e(m),vt(p,t)}}}const xt='{"title":"Introduction","local":"introduction","sections":[],"depth":1}';function _t(V){return lt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Tt extends ot{constructor(m){super(),rt(this,m,_t,wt,nt,{})}}export{Tt as component};
