import{s as Ya,f as Ja,n as Ka,o as Qa}from"../chunks/scheduler.37c15a92.js";import{S as Xa,i as Za,g as n,s as l,r as Xt,m as r,H as w,A as ts,h as i,f as a,c as p,j as b,u as Zt,x as o,n as h,B as y,k as N,y as m,a as e,v as ta,d as aa,t as sa,w as ea}from"../chunks/index.7cb9c9b8.js";import{H as na}from"../chunks/Heading.d3928e2a.js";function as(fa){let u,et,Z,nt,P,it,L,da="Don’t worry. <strong>It’s normal if this seems complex to handle right now</strong>. But we’re going to see what this Clipped Surrogate Objective Function looks like, and this will help you to visualize better what’s going on.",lt,x,va=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,pt,$,wa="We have six different situations. Remember first that we take the minimum between the clipped and unclipped objectives.",mt,H,ot,f,ia,V,ba="the clipping does not apply since the ratio is between the range",la,rt,Ba='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',ht,z,ya="In situation 1, we have a positive advantage: the <strong>action is better than the average</strong> of all the actions in that state. Therefore, we should encourage our current policy to increase the probability of taking that action in that state.",ct,I,xa="Since the ratio is between intervals, <strong>we can increase our policy’s probability of taking that action at that state.</strong>",gt,j,_a="In situation 2, we have a negative advantage: the action is worse than the average of all actions at that state. Therefore, we should discourage our current policy from taking that action in that state.",ut,O,ka="Since the ratio is between intervals, <strong>we can decrease the probability that our policy takes that action at that state.</strong>",ft,S,dt,_,Ca=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,vt,k,pa,wt,Da='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',bt,yt,q,Ma="If, like in situation 3, the advantage estimate is positive (A&gt;0), then <strong>you want to increase the probability of taking that action at that state.</strong>",xt,E,Ta="But if, like situation 4, the advantage estimate is negative, <strong>we don’t want to decrease further</strong> the probability of taking that action at that state. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",_t,A,kt,C,Pa=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,Ct,d,ma,Mt,Ra='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Tt,Y,La="much higher than in the former policy.",Pt,B,$a="If, like in situation 5, the advantage is positive, <strong>we don’t want to get too greedy</strong>. We already have a higher probability of taking that action at that state than the former policy. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",Lt,D,Ha="If, like in situation 6, the advantage is negative, we want to decrease the probability of taking that action at that state.",$t,R,za="So if we recap, <strong>we only update the policy with the unclipped objective part</strong>. When the minimum is the clipped objective part, we don’t update our policy weights since the gradient will equal 0.",Ht,G,Ia="So we update our policy  only if:",zt,M,J,oa,It,Ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',ra,K,ja="Our ratio is outside the range, but <strong>the advantage leads to getting closer to the range</strong><ul><li>Being below the ratio but the advantage is &gt; 0</li> <li>Being above the ratio but the advantage is &lt; 0</li></ul>",jt,c,Q,Oa="You might wonder why, when the minimum is the clipped ratio, the gradient is 0.",ha,Ot,Fa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> r_t(\\theta) * A_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',St,qt,Ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 - \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Et,At,Wa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 + \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Bt,Dt,g,ca,X,Sa="we restrict the range that the current policy can vary from the old one.",ga,Rt,Na='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>+</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 + \\epsilon </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Gt,Ft,Va='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>−</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 - \\epsilon </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Ut,Wt,F,qa="The final Clipped Surrogate Objective Loss for PPO Actor-Critic style looks like this, it’s a combination of Clipped Surrogate Objective function, Value Loss Function and Entropy bonus:",Nt,U,Ea,Vt,W,Aa='That was quite complex. Take time to understand these situations by looking at the table and the graph. <strong>You must understand why this makes sense.</strong> If you want to go deeper, the best resource is the article <a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf" rel="nofollow">Towards Delivering a Coherent Self-Contained Explanation of Proximal Policy Optimization” by Daniel Bick, especially part 3.4</a>.',Yt,tt,Jt;return P=new na({props:{title:"Visualize the Clipped Surrogate Objective Function",local:"visualize-the-clipped-surrogate-objective-function",headingTag:"h1"}}),H=new na({props:{title:"Case 1 and 2: the ratio is between the range",local:"case-1-and-2-the-ratio-is-between-the-range",headingTag:"h2"}}),S=new na({props:{title:"Case 3 and 4: the ratio is below the range",local:"case-3-and-4-the-ratio-is-below-the-range",headingTag:"h2"}}),A=new na({props:{title:"Case 5 and 6: the ratio is above the range",local:"case-5-and-6-the-ratio-is-above-the-range",headingTag:"h2"}}),{c(){u=n("meta"),et=l(),Z=n("p"),nt=l(),Xt(P.$$.fragment),it=l(),L=n("p"),L.innerHTML=da,lt=l(),x=n("figure"),x.innerHTML=va,pt=l(),$=n("p"),$.textContent=wa,mt=l(),Xt(H.$$.fragment),ot=l(),f=n("p"),ia=r("In situations 1 and 2, "),V=n("strong"),V.textContent=ba,la=l(),rt=new w(!1),ht=l(),z=n("p"),z.innerHTML=ya,ct=l(),I=n("p"),I.innerHTML=xa,gt=l(),j=n("p"),j.textContent=_a,ut=l(),O=n("p"),O.innerHTML=ka,ft=l(),Xt(S.$$.fragment),dt=l(),_=n("figure"),_.innerHTML=Ca,vt=l(),k=n("p"),pa=r("If the probability ratio is lower than "),wt=new w(!1),bt=r(", the probability of taking that action at that state is much lower than with the old policy."),yt=l(),q=n("p"),q.innerHTML=Ma,xt=l(),E=n("p"),E.innerHTML=Ta,_t=l(),Xt(A.$$.fragment),kt=l(),C=n("figure"),C.innerHTML=Pa,Ct=l(),d=n("p"),ma=r("If the probability ratio is higher than "),Mt=new w(!1),Tt=r(", the probability of taking that action at that state in the current policy is "),Y=n("strong"),Y.textContent=La,Pt=l(),B=n("p"),B.innerHTML=$a,Lt=l(),D=n("p"),D.textContent=Ha,$t=l(),R=n("p"),R.innerHTML=za,Ht=l(),G=n("p"),G.textContent=Ia,zt=l(),M=n("ul"),J=n("li"),oa=r("Our ratio is in the range "),It=new w(!1),ra=l(),K=n("li"),K.innerHTML=ja,jt=l(),c=n("p"),Q=n("strong"),Q.textContent=Oa,ha=r(" When the ratio is clipped, the derivative in this case will not be the derivative of the "),Ot=new w(!1),St=r("   but the derivative of either "),qt=new w(!1),Et=r(" or the derivative of "),At=new w(!1),Bt=r(" which both = 0."),Dt=l(),g=n("p"),ca=r("To summarize, thanks to this clipped surrogate objective, "),X=n("strong"),X.textContent=Sa,ga=r(" Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is > "),Rt=new w(!1),Gt=r(" or < "),Ft=new w(!1),Ut=r(" the gradient will be equal to 0."),Wt=l(),F=n("p"),F.textContent=qa,Nt=l(),U=n("img"),Vt=l(),W=n("p"),W.innerHTML=Aa,Yt=l(),tt=n("p"),this.h()},l(t){const s=ts("svelte-u9bgzb",document.head);u=i(s,"META",{name:!0,content:!0}),s.forEach(a),et=p(t),Z=i(t,"P",{}),b(Z).forEach(a),nt=p(t),Zt(P.$$.fragment,t),it=p(t),L=i(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-8fcaqu"&&(L.innerHTML=da),lt=p(t),x=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(x)!=="svelte-1kvrq9v"&&(x.innerHTML=va),pt=p(t),$=i(t,"P",{"data-svelte-h":!0}),o($)!=="svelte-kt354t"&&($.textContent=wa),mt=p(t),Zt(H.$$.fragment,t),ot=p(t),f=i(t,"P",{});var at=b(f);ia=h(at,"In situations 1 and 2, "),V=i(at,"STRONG",{"data-svelte-h":!0}),o(V)!=="svelte-w52w77"&&(V.textContent=ba),la=p(at),rt=y(at,!1),at.forEach(a),ht=p(t),z=i(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-1cqqr4g"&&(z.innerHTML=ya),ct=p(t),I=i(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-jfeco7"&&(I.innerHTML=xa),gt=p(t),j=i(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-uloelw"&&(j.textContent=_a),ut=p(t),O=i(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-1ffs0w0"&&(O.innerHTML=ka),ft=p(t),Zt(S.$$.fragment,t),dt=p(t),_=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(_)!=="svelte-1kvrq9v"&&(_.innerHTML=Ca),vt=p(t),k=i(t,"P",{});var Kt=b(k);pa=h(Kt,"If the probability ratio is lower than "),wt=y(Kt,!1),bt=h(Kt,", the probability of taking that action at that state is much lower than with the old policy."),Kt.forEach(a),yt=p(t),q=i(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-1x6bxjm"&&(q.innerHTML=Ma),xt=p(t),E=i(t,"P",{"data-svelte-h":!0}),o(E)!=="svelte-1l49ylb"&&(E.innerHTML=Ta),_t=p(t),Zt(A.$$.fragment,t),kt=p(t),C=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(C)!=="svelte-1kvrq9v"&&(C.innerHTML=Pa),Ct=p(t),d=i(t,"P",{});var st=b(d);ma=h(st,"If the probability ratio is higher than "),Mt=y(st,!1),Tt=h(st,", the probability of taking that action at that state in the current policy is "),Y=i(st,"STRONG",{"data-svelte-h":!0}),o(Y)!=="svelte-qu8nx6"&&(Y.textContent=La),st.forEach(a),Pt=p(t),B=i(t,"P",{"data-svelte-h":!0}),o(B)!=="svelte-1ptdkag"&&(B.innerHTML=$a),Lt=p(t),D=i(t,"P",{"data-svelte-h":!0}),o(D)!=="svelte-yugfug"&&(D.textContent=Ha),$t=p(t),R=i(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-1eb9ayw"&&(R.innerHTML=za),Ht=p(t),G=i(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-pg5tgk"&&(G.textContent=Ia),zt=p(t),M=i(t,"UL",{});var Qt=b(M);J=i(Qt,"LI",{});var ua=b(J);oa=h(ua,"Our ratio is in the range "),It=y(ua,!1),ua.forEach(a),ra=p(Qt),K=i(Qt,"LI",{"data-svelte-h":!0}),o(K)!=="svelte-1hd4gm6"&&(K.innerHTML=ja),Qt.forEach(a),jt=p(t),c=i(t,"P",{});var v=b(c);Q=i(v,"STRONG",{"data-svelte-h":!0}),o(Q)!=="svelte-xl5clc"&&(Q.textContent=Oa),ha=h(v," When the ratio is clipped, the derivative in this case will not be the derivative of the "),Ot=y(v,!1),St=h(v,"   but the derivative of either "),qt=y(v,!1),Et=h(v," or the derivative of "),At=y(v,!1),Bt=h(v," which both = 0."),v.forEach(a),Dt=p(t),g=i(t,"P",{});var T=b(g);ca=h(T,"To summarize, thanks to this clipped surrogate objective, "),X=i(T,"STRONG",{"data-svelte-h":!0}),o(X)!=="svelte-vpub9x"&&(X.textContent=Sa),ga=h(T," Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is > "),Rt=y(T,!1),Gt=h(T," or < "),Ft=y(T,!1),Ut=h(T," the gradient will be equal to 0."),T.forEach(a),Wt=p(t),F=i(t,"P",{"data-svelte-h":!0}),o(F)!=="svelte-d7ieux"&&(F.textContent=qa),Nt=p(t),U=i(t,"IMG",{src:!0,alt:!0}),Vt=p(t),W=i(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-256dgf"&&(W.innerHTML=Aa),Yt=p(t),tt=i(t,"P",{}),b(tt).forEach(a),this.h()},h(){N(u,"name","hf:doc:metadata"),N(u,"content",ss),N(x,"class","image table text-center m-0 w-full"),rt.a=null,N(_,"class","image table text-center m-0 w-full"),wt.a=bt,N(C,"class","image table text-center m-0 w-full"),Mt.a=Tt,It.a=null,Ot.a=St,qt.a=Et,At.a=Bt,Rt.a=Gt,Ft.a=Ut,Ja(U.src,Ea="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-objective.jpg")||N(U,"src",Ea),N(U,"alt","PPO objective")},m(t,s){m(document.head,u),e(t,et,s),e(t,Z,s),e(t,nt,s),ta(P,t,s),e(t,it,s),e(t,L,s),e(t,lt,s),e(t,x,s),e(t,pt,s),e(t,$,s),e(t,mt,s),ta(H,t,s),e(t,ot,s),e(t,f,s),m(f,ia),m(f,V),m(f,la),rt.m(Ba,f),e(t,ht,s),e(t,z,s),e(t,ct,s),e(t,I,s),e(t,gt,s),e(t,j,s),e(t,ut,s),e(t,O,s),e(t,ft,s),ta(S,t,s),e(t,dt,s),e(t,_,s),e(t,vt,s),e(t,k,s),m(k,pa),wt.m(Da,k),m(k,bt),e(t,yt,s),e(t,q,s),e(t,xt,s),e(t,E,s),e(t,_t,s),ta(A,t,s),e(t,kt,s),e(t,C,s),e(t,Ct,s),e(t,d,s),m(d,ma),Mt.m(Ra,d),m(d,Tt),m(d,Y),e(t,Pt,s),e(t,B,s),e(t,Lt,s),e(t,D,s),e(t,$t,s),e(t,R,s),e(t,Ht,s),e(t,G,s),e(t,zt,s),e(t,M,s),m(M,J),m(J,oa),It.m(Ga,J),m(M,ra),m(M,K),e(t,jt,s),e(t,c,s),m(c,Q),m(c,ha),Ot.m(Fa,c),m(c,St),qt.m(Ua,c),m(c,Et),At.m(Wa,c),m(c,Bt),e(t,Dt,s),e(t,g,s),m(g,ca),m(g,X),m(g,ga),Rt.m(Na,g),m(g,Gt),Ft.m(Va,g),m(g,Ut),e(t,Wt,s),e(t,F,s),e(t,Nt,s),e(t,U,s),e(t,Vt,s),e(t,W,s),e(t,Yt,s),e(t,tt,s),Jt=!0},p:Ka,i(t){Jt||(aa(P.$$.fragment,t),aa(H.$$.fragment,t),aa(S.$$.fragment,t),aa(A.$$.fragment,t),Jt=!0)},o(t){sa(P.$$.fragment,t),sa(H.$$.fragment,t),sa(S.$$.fragment,t),sa(A.$$.fragment,t),Jt=!1},d(t){t&&(a(et),a(Z),a(nt),a(it),a(L),a(lt),a(x),a(pt),a($),a(mt),a(ot),a(f),a(ht),a(z),a(ct),a(I),a(gt),a(j),a(ut),a(O),a(ft),a(dt),a(_),a(vt),a(k),a(yt),a(q),a(xt),a(E),a(_t),a(kt),a(C),a(Ct),a(d),a(Pt),a(B),a(Lt),a(D),a($t),a(R),a(Ht),a(G),a(zt),a(M),a(jt),a(c),a(Dt),a(g),a(Wt),a(F),a(Nt),a(U),a(Vt),a(W),a(Yt),a(tt)),a(u),ea(P,t),ea(H,t),ea(S,t),ea(A,t)}}}const ss='{"title":"Visualize the Clipped Surrogate Objective Function","local":"visualize-the-clipped-surrogate-objective-function","sections":[{"title":"Case 1 and 2: the ratio is between the range","local":"case-1-and-2-the-ratio-is-between-the-range","sections":[],"depth":2},{"title":"Case 3 and 4: the ratio is below the range","local":"case-3-and-4-the-ratio-is-below-the-range","sections":[],"depth":2},{"title":"Case 5 and 6: the ratio is above the range","local":"case-5-and-6-the-ratio-is-above-the-range","sections":[],"depth":2}],"depth":1}';function es(fa){return Qa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ps extends Xa{constructor(u){super(),Za(this,u,es,as,Ya,{})}}export{ps as component};
